

Func min3($a, $b, $c)
	Local $dummy
	$dummy = $a
	If $b < $dummy Then $dummy = $b
	If $c < $dummy Then $dummy = $c
	Return $dummy
EndFunc   ;==>min3

Func LevenshteinDistance($s, $t)
	Local $n, $m
	$n = StringLen($s)
	$m = StringLen($t)
	If $s = $t Then Return 0
	If $s = "" Then Return $m
	If $t = "" Then Return $n
	Local $d[$n + 1][$m + 1], $i, $j, $cost
	For $i = 0 To $n
		$d[$i][0] = $i
	Next
	For $j = 0 To $m
		$d[0][$j] = $j
	Next
	For $i = 1 To $n
		For $j = 1 To $m
			If StringMid($s, $i, 1) = StringMid($t, $j, 1) Then
				$cost = 0
			Else
				$cost = 1
			EndIf
			$d[$i][$j] = min3($d[$i - 1][$j] + 1, $d[$i][$j - 1] + 1, $d[$i - 1][$j - 1] + $cost)
		Next
	Next
	Return $d[$n][$m]
EndFunc   ;==>LevenshteinDistance

Func CompTstr($s, $t)
	Local $n, $m
	$n = StringLen($s)
	$m = StringLen($t)
	If $n < $m Then $n = $m
	Return ($n - LevenshteinDistance($s, $t)) / $n
EndFunc   ;==>CompTstr

Func _Dist_Calc($s1, $s2)

	; Tests:
;~ 	1. LevenshteinDistance: Gewichtung: 50 %
;~ 	2. Partial Match (erste 25% und letzte 25% und mittlere 50%) zusammen 50%

	; Gleiches Wort = Kein Abstand
	If $s1 = $s2 Then Return 0

	Local $iL1 = StringLen($s1), $iL2 = StringLen($s2), $iLD = ($iL1 + $iL2) / 2, $nRet
	If Not $iL1 Or Not $iL2 Then Return 100

	Local $Partial25Len1 = Ceiling($iL1/4), $Partial25Len2 = Ceiling($iL2/4)

	If Not StringInStr($s2, StringLeft($s1, $Partial25Len1), 0) Then $nRet += 1/6
	If Not StringInStr($s2, StringRight($s1, $Partial25Len1), 0) Then $nRet += 1/6
	If Not StringInStr($s2, StringTrimRight(StringTrimLeft($s1, $Partial25Len1),$Partial25Len1), 0) Then $nRet += 1/6

	If Not StringInStr($s1, StringLeft($s2, $Partial25Len2), 0) Then $nRet += 1/6
	If Not StringInStr($s1, StringRight($s2, $Partial25Len2), 0) Then $nRet += 1/6
	If Not StringInStr($s1, StringTrimRight(StringTrimLeft($s2, $Partial25Len2),$Partial25Len2), 0) Then $nRet += 1/6

	$nRet += LevenshteinDistance($s1, $s2) / $iLD


	Return $nRet

EndFunc   ;==>_Dist_Calc